<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\NovoChecklistService;

class NovoChecklistController extends FMCrud{
    protected $dataSourceName = 'fcm_checklist';
    protected $NovoChecklistService;
   
    public function __construct($crudService, $environment, NovoChecklistService $NovoChecklistService) {
        parent::__construct($crudService, $environment);
        $this->NovoChecklistService = $NovoChecklistService;
    }

    public function getLocal(DTO\Request $request, DTO\Response $response) {
        $novoFiltro = $this->NovoChecklistService->buscaNomeLocais();
        $dtsVal = new DataSet('local', $novoFiltro);
        $response->addDataSet($dtsVal);
    }
    
    public function getDadosCard(DTO\Request $request, DTO\Response $response){
        
        $dadosLocal = $this->NovoChecklistService->buscaNomeLocal();
        $dtsVal1 =  new DataSet('dadosLocal', $dadosLocal);
        $response->addDataSet($dtsVal1);
    }
    
    public function buscaDadosCardPadrao(DTO\Request $request, DTO\Response $response){
        $dados =  $this->NovoChecklistService->buscaDadosCardPadrao();
        $dtsVal =  new DataSet('dados', $dados);
        $response->addDataSet($dtsVal);
    }
    
    public function buscaDadosAtividadeseCriterios(DTO\Request $request, DTO\Response $response){
        $dados =  $this->NovoChecklistService->buscaDadosAtividadeseCriterios();
        $dtsVal =  new DataSet('dados', $dados);
        $response->addDataSet($dtsVal);
    }
    
    public function buscaDadosCardAtividades(DTO\Request $request, DTO\Response $response){
        $dados =  $this->NovoChecklistService->buscaDadosCardAtividades();
        $dtsVal =  new DataSet('dados', $dados);
        $response->addDataSet($dtsVal);
    }
    
    public function insertNovaAtividadeBase(DTO\Request $request, DTO\Response $response){
        
        $parametro = $request->getParameters();
        // debugApi($parametro);
        
        $nratividade      = $parametro['novaAtividade']['NRATIVIDADE'];
        $nmatividade = $parametro['novaAtividade']['NMATIVIDADE'];
        $nrtarefa = $parametro['novaAtividade']['NRTAREFA'];
        $nmtarefa = $parametro['novaAtividade']['NMTAREFA'];
        $nratividade = $parametro['novaAtividade']['NRATIVIDADE'];
        $dspopservico = $parametro['novaAtividade']['DSPOPSERVICO'];
        $nrcriteriotarefa = $parametro['novaAtividade']['NRCRITERIOTAREFA'];
        $dscriteriotarefa = $parametro['novaAtividade']['DSCRITERIOTAREFA'];
        $idtipocriterio = $parametro['novaAtividade']['IDTIPOCRITERIO'];
        $nrtagstarefa = $parametro['novaAtividade']['NRTAGSTAREFA'];
        $dstagstarefa = $parametro['novaAtividade']['DSTAGSTAREFA'];
        $idativo = $parametro['novaAtividade']['IDATIVO'];
        $nrorg = $parametro['novaAtividade']['NRORG'];
    
        $var =  $this->NovoChecklistService->insertNovaAtividadeBase($nratividade, $nmatividade, $nrtarefa, $nmtarefa, $dspopservico, $nrcriteriotarefa, $dscriteriotarefa, $idtipocriterio, $nrtagstarefa, $dstagstarefa);
        $dtsVal =  new DataSet('novaAtividade', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function filtroItens(DTO\Request $request, DTO\Response $response) {
        
        $novoFiltro =  $this->NovoChecklistService->filtroItens();
        $dtsVal =  new DataSet('filtro', $novoFiltro);
        $response->addDataSet($dtsVal);
        
    }

    public function filtroTags(DTO\Request $request, DTO\Response $response) {
            $parametro = $request->getParameters();
            $novoFiltro =  $this->NovoChecklistService->filtroTags($parametro);
            $dtsVal =  new DataSet('filtroTags', $novoFiltro);
            $response->addDataSet($dtsVal);
            
    }
    
    public function insertNovoChecklistBase(DTO\Request $request, DTO\Response $response) {
        
        $parametro = $request->getParameters();
        
        // Tabela - FCM_ATIVIDADECHK
        
        $nratividadechk = $parametro['arrayDados']['NRATIVIDADECHK'];
        $nratividade = $parametro['arrayDados']['NRATIVIDADE'];
        $nrchecklist = $parametro['arrayDados']['NRCHECKLIST'];
        $idativo = $parametro['arrayDados']['IDATIVO'];
        $nrorg = $parametro['arrayDados']['NRORG'];
        $dtinclusao = $parametro['arrayDados']['DTINCLUSAO'];
        
        // Tabela - FCM_TAREFACHK
        //Dados Iguais a table acima IDATIVO, NRORG, DTINCLUSAO, NRCHECKLIST, NRATIVIDADECHK
        $nrtarefachk = $parametro['arrayDados']['NRTAREFACHK'];
        $nrtarefa = $parametro['arrayDados']['NRTAREFA'];
        
        // Tabela - FCM_CRITERIOTAREFACHK
        //Dados Iguais a table acima IDATIVO, NRORG, DTINCLUSAO, NRTAREFACHK,
        $nrcriteriotarefachk = $parametro['arrayDados']['NRCRITERIOTAREFACHK'];
        $nrcriteriotarefa = $parametro['arrayDados']['NRCRITERIOTAREFA'];
        
        // Tabela - FCM_TAGSCHKTAREFA
        //Dados Iguais a table acima IDATIVO, NRORG, DTINCLUSAO, NRTAREFACHK,
        $nrtagschktarefa = $parametro['arrayDados']['NRTAGSCHKTAREFA'];
        $nrtagstarefa = $parametro['arrayDados']['NRTAGSTAREFA'];
        
        $var = $this->NovoChecklistService->insertNovoChecklistBase(/*Passar Parametros vindo do front-> controler-> Service (Verificar com o Arthur)*/);
        $dtsVal =  new DataSet('arrayDados', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function getGrupo(DTO\Request $request, DTO\Response $response) {
        $parametro = $request->getParameters();
        $novoFiltro = $this->NovoChecklistService->criaGruposTags($parametro);
        $dtsVal = new DataSet('grupos', $novoFiltro);
        $response->addDataSet($dtsVal);
        
    }
    
    public function buscaDadosCriteriosNaoConformidades(DTO\Request $request, DTO\Response $response) {
        $parametro1 = $request->getParameters();
        $parametro2 = $request->getParameters();
        $novoFiltro = $this->NovoChecklistService->buscaDadosCriteriosNaoConformidades($parametro1, $parametro2);
        $dtsVal = new DataSet('dados', $novoFiltro);
        $response->addDataSet($dtsVal);
    }
}
?>