<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class NewLocalAtendimentoFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
   
    public function getFactoryLocal() {
        $sql = "SELECT NMTIPOLOCALCLI, NRTIPOLOCALCLI, IDTIPOLOCALCLI
                  FROM FCM_TIPOLOCALCLI";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactoryLocalParent() {
        $sql = "SELECT NMLOCALCLIENTE, NRLOCALCLIENTE
                 FROM FCM_LOCALCLI
                WHERE NRLOCALCLIENTEPAI != 2 or NRLOCALCLIENTEPAI IS NULL";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactorySector() {
        $sql = "SELECT NMSETOR, NRSETOR
                  FROM FCM_SETOR";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactoryGroup() {
        $sql = "SELECT NMGRUPOLOCAL, NRGRUPOLOCAL
                  FROM FCM_GRUPOLOCAL";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactoryEmployee() {
        $sql = "SELECT NMFUNCIONARIO, NRFUNCIONARIO
                  FROM FCM_FUNCIONARIO";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactoryCheckList() {
        $sql = "SELECT NMCHECKLIST, NRCHECKLIST
                  FROM FCM_CHECKLIST";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function insertFactoryLocalAt($params) {
        $sql = "INSERT INTO FCM_LOCALCLI
                 VALUES(:NRLOCALCLIENTE, :NMLOCALCLIENTE, :CDCLIENTE, :NRTIPOLOCALCLI, :NRLOCALCLIENTEPAI, :NRCHECKLISTPADR, :NRSETOR, :DSICONELOCAL, :DSQRCODE, 'S', :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO, :DTULTATU, :CDOPERULTATU, :NRORGULTATU, :NRGRUPOLOCAL)";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
    }
    
    public function insertFactoryTask($params) {
        $sql = "INSERT INTO FCM_TAREFAAGEND
                 VALUES(:NRTAREFAAGEND, :NRCHECKLISTAGEND, :NRFUNCIONARIO, SYSDATE, :DSOBSTAREFAAGEND, 'S', :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO, :DTULTATU, :CDOPERULTATU, :NRORGULTATU, :NRTAREFACHK, 'S')";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
    }
    
    public function getFactoryLocalAtToUpdate($param) {
        $sql = "SELECT NRLOCALCLIENTE, NMLOCALCLIENTE, NRTIPOLOCALCLI, NRLOCALCLIENTEPAI, NRCHECKLISTPADR, NRSETOR
                  FROM FCM_LOCALCLI
                WHERE NRLOCALCLIENTE = :NRLOCALCLIENTE";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute($param);
        return $std->fetchAll();
    }
    
    public function updateFactoryLocalAt($param) {
        $sql = "UPDATE FCM_LOCALCLI
                    SET NRLOCALCLIENTE = :NRLOCALCLIENTE,
                        NMLOCALCLIENTE = :NMLOCALCLIENTE,
                        NRTIPOLOCALCLI = :NRTIPOLOCALCLI,
                        NRLOCALCLIENTEPAI = :NRLOCALCLIENTEPAI,
                        NRCHECKLISTPADR = :NRCHECKLISTPADR,
                        NRSETOR = :NRSETOR,
                        DTINCLUSAO = SYSDATE
                WHERE NRLOCALCLIENTE = :NRLOCALCLIENTE";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($param);
    }
}
?>