<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class NovoChecklistFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }

    public function buscaNomeLocais() {
        
        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI
                  FROM FCM_TIPOLOCALCLI";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }

    public function filtroTags($titulo) {
        
        $sql = "SELECT FCM_TAREFA.NRTAREFA, FCM_TAREFA.NMTAREFA, FCM_TAREFA.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE
                      FROM FCM_TAREFA
                      join FCM_ATIVIDADE
                        ON FCM_TAREFA.NRATIVIDADE = FCM_ATIVIDADE.NRATIVIDADE
                       AND FCM_TAREFA.NRORGINCLUSAO = FCM_ATIVIDADE.NRORGINCLUSAO
                  WHERE FCM_TAREFA.NRATIVIDADE IN( ".$titulo.") ";
        
        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscaGrupoTags ($tarefas) {
       $sql = "SELECT DISTINCT DSTAGSTAREFA 
          FROM FCM_TAGSTAREFA
         WHERE NRTAREFA IN (".$tarefas.") ";
         
        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }
    
    public function filtroItens() {
        
        $sql = "SELECT NRATIVIDADE, NMATIVIDADE
                  FROM FCM_ATIVIDADE";
        
        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscaDadosCardAtividades() {
        
        $sql = "SELECT FCM_TIPOLOCALCLI.NRTIPOLOCALCLI, FCM_TIPOLOCALCLI.NMTIPOLOCALCLI, FCM_TAREFACHK.NRTAREFACHK, FCM_TAREFACHK.NMTAREFACHK
                  FROM FCM_TIPOLOCALCLI, FCM_TAREFACHK";
                  
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscaDadosAtividadeseCriterios() {
        
        $sql = "SELECT 
                    FCM_ATIVIDADE.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE,
                    FCM_TAREFA.NRTAREFA, FCM_TAREFA.NMTAREFA, FCM_TAREFA.NRATIVIDADE
                FROM 
                   FCM_ATIVIDADE, FCM_TAREFA
                WHERE 
                   FCM_ATIVIDADE.NRATIVIDADE = FCM_TAREFA.NRATIVIDADE";
                  
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        
        return $std->fetchAll();
    }
    
    public function buscaNomeLocal() {
        
        $sql = "SELECT 
        FCM_LOCALCLI.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE, FCM_CHECKlIST.NMCHECKLIST, FCM_TIPOLOCALCLI.DSICONETIPOLOCAL, FCM_TIPOLOCALCLI.NMTIPOLOCALCLI,
        FCM_CHECKlIST.DSCHECKLIST, FCM_CHECKlIST.NRCRITICIDADECHK
                   FROM FCM_RELACLOCALCHK,  FCM_LOCALCLI, FCM_CHECKlIST, FCM_TIPOLOCALCLI
                   WHERE  FCM_RELACLOCALCHK.NRLOCALCLIENTE = FCM_LOCALCLI.NRLOCALCLIENTE
                   AND FCM_RELACLOCALCHK.NRCHECKLIST = FCM_CHECKlIST.NRCHECKLIST
                   AND FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI";

        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    //fazer tres funções para cada insert, falta informacoes das colunas ainda até NRORG
    
    //insere nova atividade
    public function insertNovaAtividadeBase($parametrosAtividades) {
        
    $sql = " INSERT INTO NRATIVIDADE (NRATIVIDADE, NMATIVIDADE, IDATIVO, NRORG)
    VALUES (:NRATIVIDADE, :NMATIVIDADE, :DSICONEATIVIDADE, 'S', 20)";

    $std = $this->connection->prepare($sql);
    
    $std->execute($parametrosAtividades);
    
    }
    
    public function insertNovaTarefaBase($parametrosTarefas) {
    
    $sql = " INSERT INTO FCM_TAREFA (NRTAREFA, NMTAREFA, NRATIVIDADE, DSPOPSERVICO, IDATIVO, NRORG)
    VALUES (:NRTAREFA, :NMTAREFA, :NRATIVIDADE, :DSPOPSERVICO, 'S', 20)";

    $std = $this->connection->prepare($sql);
    
    $std->execute($parametrosTarefas);
    
    }
    
    public function insertNovoCriterioBase($parametrosCriterio) {
    
    $sql = " INSERT INTO FCM_CRITERIOTAREFA (NRCRITERIOTAREFA, DSCRITERIOTAREFA, NRTAREFA, IDTIPOCRITERIO, IDATIVO, NRORG)
    VALUES (:NRCRITERIOTAREFA, :DSCRITERIOTAREFA, :NRTAREFA, :IDTIPOCRITERIO, 'S', 20)";

    $std = $this->connection->prepare($sql);
    
    $std->execute($parametrosCriterio);
    
    }
    
    public function insertNovoTagBase($parametrosTags) {
    
    $sql = " INSERT INTO FCM_TAGSTAREFA (NRTAGSTAREFA, NRTAREFA, DSTAGSTAREFA, IDATIVO, NRORG)
    VALUES (:NRTAGSTAREFA, :NRTAREFA, :DSTAGSTAREFA, 'S', 20";

    $std = $this->connection->prepare($sql);
    
    $std->execute($parametrosTags);
    
    }
    
    public function insertNovoChecklistBase($parametroNovoChecklist) {
        $sql = "";
        $std =  $this->connection->prepare($sql);
        $std = execute($parametroNovoChecklist);
    }
    
    public function buscaDadosCriteriosNaoConformidades($parametro){
        $sql = "SELECT FCM_TAGSTAREFA.NRTAGSTAREFA, FCM_TAGSTAREFA.DSTAGSTAREFA, FCM_CRITERIOTAREFA.NRCRITERIOTAREFA, 
                       FCM_CRITERIOTAREFA.DSCRITERIOTAREFA, FCM_TAREFA.NRTAREFA, FCM_TAREFA.NMTAREFA, 
                       FCM_ATIVIDADE.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE
                  FROM FCM_TAGSTAREFA
                  LEFT JOIN FCM_CRITERIOTAREFA
                    ON FCM_CRITERIOTAREFA.NRTAREFA = FCM_TAGSTAREFA.NRTAREFA
                   AND FCM_CRITERIOTAREFA.NRORG = FCM_TAGSTAREFA.NRORG
                  JOIN FCM_TAREFA
                    ON FCM_TAREFA.NRTAREFA = FCM_TAGSTAREFA.NRTAREFA
                   AND FCM_TAREFA.NRORG = FCM_TAGSTAREFA.NRORG 
                  JOIN FCM_ATIVIDADE
                    ON FCM_ATIVIDADE.NRATIVIDADE = FCM_TAREFA.NRATIVIDADE
                   AND FCM_ATIVIDADE.NRORG = FCM_TAREFA.NRORG 
                 WHERE FCM_TAREFA.NRTAREFA IN (".$parametro['NRTAREFA'].")
                   AND FCM_TAGSTAREFA.DSTAGSTAREFA = '".$parametro['DSTAGSTAREFA']."'
                  GROUP BY FCM_TAGSTAREFA.NRTAGSTAREFA, FCM_TAGSTAREFA.DSTAGSTAREFA, FCM_CRITERIOTAREFA.NRCRITERIOTAREFA, 
                       FCM_CRITERIOTAREFA.DSCRITERIOTAREFA, FCM_TAREFA.NRTAREFA, FCM_TAREFA.NMTAREFA, 
                       FCM_ATIVIDADE.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE
                  ORDER BY FCM_ATIVIDADE.NRATIVIDADE,  FCM_TAREFA.NRTAREFA, FCM_TAGSTAREFA.NRTAGSTAREFA, FCM_CRITERIOTAREFA.NRCRITERIOTAREFA";
        
        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
        
    }
    
    public function criaGruposTags($parametro) {
        $sql = "SELECT DISTINCT DSTAGSTAREFA 
                 FROM FCM_TAGSTAREFA
                 WHERE NRTAREFA IN (".$parametro.")";
        
        $std = $this->connection->prepare($sql);
    
        $std->execute();
        return $std->fetchAll();
    }
}
?>