<?php
namespace FM\Service;

use FM\Factory\NovoChecklistFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;

class NovoChecklistService {
    
    protected $NovoChecklistFactory;
    protected $Environment;
    protected $newCode;
    
    public function __construct (NovoChecklistFactory $NovoChecklistFactory, Environment $Environment, NewCode $newCode) {
        $this->NovoChecklistFactory  = $NovoChecklistFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function buscaNomeLocais(){
        
        $local = $this->NovoChecklistFactory->buscaNomeLocais();
        
        return $local;
    }
    
    public function filtroItens(){
        
        $filtroItens = $this->NovoChecklistFactory->filtroItens();
        
        return $filtroItens;
    }
    
    public function filtroTags($titulo){
        $variavel = implode(',', $titulo);
        
        $filtroItens = $this->NovoChecklistFactory->filtroTags($variavel);
        
        return $filtroItens;
    }    

    public function buscaDadosCardPadrao(){
        
        $dados =  $this->NovoChecklistFactory->buscaDadosCardPadrao();
        
        return $dados;
        
    }
    
    public function buscaDadosAtividadeseCriterios(){
        
        $dados =  $this->NovoChecklistFactory->buscaDadosAtividadeseCriterios();
        
        return $dados;
        
    }
    
    public function buscaNomeLocal(){
        
        $dados =  $this->NovoChecklistFactory->buscaNomeLocal();
        
        return $dados;
        
    }
    
    public function buscaDadosCardAtividades(){
        
        $dados =  $this->NovoChecklistFactory->buscaDadosCardAtividades();
        
        return $dados;
        
    }
    
    public function insertNovaAtividadeBase($nratividade, $nmatividade, $nrtarefa, $nmtarefa, $dspopservico, $nrcriteriotarefa, $dscriteriotarefa, $idtipocriterio, $nrtagstarefa, $dstagstarefa ){
        
        $nrorcaescopodoc = $this->newCode->getCodeByTableName("", $nrorg, 1, 10, true);
        //criar tres arrays para cada requisição

        $parametrosAtividades =  array (
            
            "NRATIVIDADE" => $nratividade,
            "NMATIVIDADE" => $nmatividade,
        );
        
        $parametrosTarefas =  array (
            
            "NRTAREFA" => $nrtarefa,
            "NMTAREFA" => $nmtarefa,
            "NRATIVIDADE" => $nratividade,
            "DSPOPSERVICO" => $dspopservico
        );
        
        $parametrosCriterio =  array (
            
            "NRCRITERIOTAREFA" => $nrcriteriotarefa,
            "DSCRITERIOTAREFA" => $dscriteriotarefa,
            "NRTAREFA" => $nrtarefa,
            "IDTIPOCRITERIO" => $idtipocriterio
        );
        
        $parametrosTags =  array (
            
            "NRTAGSTAREFA" => $nrtagstarefa,
            "NRTAREFA" => $nrtarefa,
            "DSTAGSTAREFA" => $dstagstarefa
        );
        
        //chamar elas no factory de forma logica, no caso na ordem atividade, tarefa, critério,tag.
        $novaAtividade =  $this->NovoChecklistFactory->insertNovaAtividadeBase($parametrosAtividades);
        $novaTarefa = $this->NovoChecklistFactory->insertNovaTarefaBase($parametrosTarefas);
        $novoCriterio = $this->NovoChecklistFactory->insertNovoCriterioBase($parametrosCriterio);
        $novoTag = $this->NovoChecklistFactory->insertNovoTagBase($parametrosTags);
        
        return 'OK';
    }
    
    public function insertNovoChecklistBase(/*Passar parametros vindos do controler aqui*/) {
        
        
         $nrorcaescopodoc = $this->newCode->getCodeByTableName("", $nrorg, 1, 10, true);
         
         $parametroNovoChecklist =  array(
             "NRATIVIDADECHK" => $nratividadechk,
             "NRATIVIDADE" => $nratividade,
             "NRCHECKLIST" => $nrchecklist,
             "IDATIVO" => $idativo,
             "NRORG" => $nrorg,
             "DTINCLUSAO" => $dtinclusao,
             "NRTAREFACHK" => $nrtarefachk,
             "NRTAREFA" => $nrtarefa,
             "NRCRITERIOTAREFACHK" => $nrcriteriotarefachk,
             "NRCRITERIOTAREFA" => $nrcriteriotarefa,
             "NRTAGSTAREFA" => $nrtagschktarefa
        );
        
        $novoChecklist =  $this->NovoChecklistFactory->insertNovoChecklistBase($parametroNovoChecklist);
         
    }
    
    public function criaGruposTags($parametro) {
        $variavel = array();
        foreach($parametro as $tarefa){
            $variavel[] = $tarefa['value'];
        }
        $variavel = implode(',', $variavel);
        $grupoTags = $this->NovoChecklistFactory->criaGruposTags($variavel);
        $teste = array($grupoTags);
        $teste =  $teste[0];
        $resposta = $teste;
        foreach($teste as $index=>$grupo){
            // debugApi([$index,$grupo]);
            $dadosInformacao = array(
                "NRTAREFA" => $variavel,
                "DSTAGSTAREFA" => $grupo['DSTAGSTAREFA']
            );
            $teste[$index]['list'] = $this->NovoChecklistFactory->buscaDadosCriteriosNaoConformidades($dadosInformacao);
            $resposta[$index]['list'] = array();
        }
        foreach($teste as $index=>$value){
            foreach($teste[$index]['list'] as $index1=>$value1){
                $posicao =  $index1;
                foreach($resposta[$index]['list'] as $index2=>$value2){
                    if($value2['NRATIVIDADE'] == $value1['NRATIVIDADE'] && $index1 > $index2){
                        $posicao = $index2;
                    }
                }
                if($posicao ==  $index1) {
                   $resposta[$index]['list'][] = $value1;
                    // var_dump($resposta[$index]['list'][count($resposta[$index]['list']) -1]);
                  $resposta[$index]['list'][count($resposta[$index]['list']) -1]['list'][] = array(
                      "NRCRITERIOTAREFA" => $value1['NRCRITERIOTAREFA'],
                      "DSCRITERIOTAREFA" => $value1['DSCRITERIOTAREFA']
                      );
                } else {
                  // $resposta[$index]['list'][$posicao] = $value1;
                  $resposta[$index]['list'][$posicao]['list'][] = array(
                      "NRCRITERIOTAREFA" => $value1['NRCRITERIOTAREFA'],
                      "DSCRITERIOTAREFA" => $value1['DSCRITERIOTAREFA']
                      );
                }
            }
        }
         // debugApi([$resposta]);
        return $resposta;
    }
    
    public function buscaDadosCriteriosNaoConformidades($parametro1, $parametro2){
        $variavel1 = implode(',', $parametro1);
        $variavel2 = implode(',', $parametro2);
        
        $criterios = $this->NovoChecklistFactory->buscaDadosCriteriosNaoConformidades($variavel, $variavel2);
        
        return $criterios;
    }
}
?>