import {
  Metadata, IDictionary, IEventParam, Http, Router, Loader,
} from '@zeedhi/core';
import {
  Button, Form, Card, Tabs, Text, IComponentRender, AlertService,
  Switch, Container, FileInput, Textarea, TextInput,
} from '@zeedhi/common';

export class ChecklistController {
  public modalController = Loader.getInstance('ModalControllerAddAtividade');

  public modalController1 = Loader.getInstance('ModalControllerAddProcedimento');

  public list1: IDictionary = [];

  public valida: IDictionary = [];

  public variavel: IDictionary = {};

  public titulo: IDictionary = {};

  public icone: IDictionary = {};

  public descricao: IDictionary = {};

  public conformidades: IDictionary = {};

  public modeloCriterio: IDictionary = {};

  public criterio: IDictionary = [];

  public renderizaCard() {
    const nome: IDictionary = [];
    Http.get('/getDadosCard').then((response) => {
      response.data.dataset.dadosLocal.forEach((dados: IDictionary) => {
        nome.push(this.geraCard({
          titulo: dados.NMTIPOLOCALCLI,
          nmChecklist: dados.NMCHECKLIST,
          descricao: dados.DSCHECKLIST,
          conformidades: dados.NRCRITICIDADECHK,
        }));
      });
    });
    Metadata.getInstance<Card>('segundaColunaTabs').children = nome as IComponentRender[];
  }

  public renderizaCardAtividades() {
    const nome: IDictionary = [];
    Http.get('/buscaDadosAtividadeseCriterios').then((response) => {
      response.data.dataset.dados.forEach((dados: IDictionary) => {
        nome.push(this.criaCardAtividades(dados.NMATIVIDADE, dados.NMTAREFA));
      });
    });
    Metadata.getInstance<Card>('colunaTab2').children = nome as IComponentRender[];
  }

  public geraCard(variavel: IDictionary) {
    return {
      name: 'cardTotal',
      component: 'ZdCollapseCard',
      cssClass: 'zd-mt-2',
      header: [
        {
          name: 'linhaCard',
          component: 'ZdRow',
          children: [
            {
              name: 'iconeCard',
              component: 'ZdText',
              text: '',
              cssClass: 'zd-pt-2 zd-pe-2',
              tag: 'v-icon',
            },
            {
              name: 'titulo',
              component: 'ZdText',
              text: `${variavel.titulo}`,
              cssClass: 'zd-my-3',
              style: {
                color: '#2196f3',
                'font-weight': 'bold',
              },
            },
          ],
        },
      ],
      children: [
        {
          name: 'cardCentral',
          component: 'ZdCard',
          cssClass: 'zd-mb-4',
          hover: true,
          elevation: 4,
          children: [
            {
              name: 'linhaCard',
              component: 'ZdRow',
              children: [
                {
                  name: 'colunaCard',
                  component: 'ZdCol',
                  cols: '2',
                  children: [
                    {
                      name: 'tituloCardInterno',
                      component: 'ZdText',
                      text: `${variavel.nmChecklist}`,
                      style: {
                        color: '#6c757d',
                        'font-weight': 'bold',
                      },
                    },
                  ],
                },
                {
                  name: 'primeiraColunaCardInterno',
                  component: 'ZdCol',
                  cols: '5',
                  children: [
                    {
                      name: 'descicaoCardInterno',
                      component: 'ZdText',
                      text: `${variavel.descricao}`,
                      style: {
                        color: '#6c757d',
                      },
                    },
                  ],
                },
                {
                  name: 'segundaColunaCardInterno',
                  component: 'ZdCol',
                  cols: '2',
                  children: [
                    {
                      name: 'conformidades',
                      component: 'ZdText',
                      text: `${variavel.conformidades} Conformidades`,
                      style: {
                        color: '#6c757d',
                      },
                    },
                  ],
                },
                {
                  name: 'terceiraColunaBotao',
                  component: 'ZdCol',
                  cols: '3',
                  children: [
                    {
                      name: 'linhaBotao',
                      component: 'ZdRow',
                      cssClass: 'zd-justify-end',
                      children: [
                        {
                          name: 'botao1',
                          component: 'ZdButton',
                          icon: 'true',
                          iconName: 'mdi-content-copy',
                          events: {
                            click: '{{ChecklistController.copiaCards}}',
                          },
                        },
                        {
                          name: 'botao2',
                          component: 'ZdButton',
                          icon: 'true',
                          iconName: 'mdi-pencil',
                          events: {
                          },
                        },
                      ],
                    },
                  ],
                },
              ],
            },
          ],
        },
      ],
    };
  }

  // função para copiar cards internos(não apagar)
  public copiaCards({ component }: IEventParam<Button>) {
    const variavel1 = this.getParent1(component, 'ZdCard');
    if (variavel1) {
      variavel1.parent.children.push(variavel1);
    }
  }

  public getParent1(component: IEventParam<any>, nameComponent: string): any {
    if (component.component === nameComponent) {
      return component;
    }
    if (component.parent) {
      return this.getParent1(component.parent, nameComponent);
    }
    return null;
  }

  public getParent({ component }:{ component:any }, nameComponent: string): any {
    if (component.component === nameComponent) {
      return component;
    }
    if (component.parent) {
      return this.getParent(component.parent, nameComponent);
    }
    return null;
  }

  // Cria Card Atividades e Critérios
  public criaCardAtividades(titulo: string, descricao: string) {
    return {
      name: '',
      component: 'ZdCol',
      children: [
        {
          name: 'cardTab2',
          component: 'ZdCollapseCard',
          expanded: false,
          readonly: true,
          expandButton: {
            name: 'botaoEditarTabs',
            component: 'ZdButton',
            iconName: 'mdi-pencil',
            color: 'secundary',
            icon: true,
            events: {
              click: '{{ChecklistController.editarCardAtividades}}',
            },
          },
          header: [
            {
              name: 'linhaConteudoTab2',
              component: 'ZdRow',
              children: [
                {
                  name: 'colunaConteudoTab2',
                  component: 'ZdCol',
                  cols: 3,
                  children: [
                    {
                      name: 'linhaBotaoTab2',
                      component: 'ZdRow',
                      children: [
                        {
                          name: 'botaoEditarTab2',
                          component: 'ZdText',
                          text: '',
                          cssClass: 'zd-pt-2 zd-pe-2',
                          color: '',
                          tag: '',
                        },
                        {
                          name: 'tituloCardTab2',
                          component: 'ZdText',
                          text: `${titulo}`,
                          cssClass: 'zd-my-3',
                        },
                      ],
                    },
                  ],
                },
                {
                  name: 'colunaInformacaoCardTab2"',
                  component: 'ZdCol',
                  cols: 3,
                  children: [
                    {
                      name: 'tituloCardTab2',
                      component: 'ZdText',
                      text: `${descricao}`,
                      cssClass: 'zd-my-3',
                    },
                  ],
                },
              ],
            },
          ],
          children: [
            {
              name: 'containerForms',
              component: 'ZdForm',
              grid: {
                cols: 12,
              },
              children: [
                {
                  name: 'formsNovoChecklist1',
                  component: 'ZdForm',
                  grid: {
                    cols: 12,
                  },
                  events: {
                    onCreated: '{{ModalControllerAddProcedimento.createHeaderFooterModal}}',
                    onBeforeDestroy: '{{ModalControllerAddProcedimento.destroyHeaderFooterModal}}',
                  },
                  children: [
                    {
                      name: 'tarefasNovoChecklist1',
                      component: 'ZdTextInput',
                      label: 'Tarefa',
                      cssClass: 'zd-pr-1',
                      validations: {
                        required: '{}',
                      },
                      grid: {
                        cols: 3,
                      },
                    },
                    {
                      name: 'criterioNovoChecklist1',
                      component: 'ZdTextInput',
                      label: 'Critério de Não-Conformidades',
                      cssClass: 'zd-pr-1',
                      validations: {
                        required: '{}',
                      },
                      grid: {
                        cols: 3,
                      },
                    },
                    {
                      name: 'tagNovoChecklist1',
                      component: 'ZdTextInput',
                      label: 'Tag de Serviço',
                      cssClass: 'zd-pr-1',
                      validations: {
                        required: '{}',
                      },
                      grid: {
                        cols: 3,
                      },
                    },
                    {
                      name: 'form_footer2',
                      component: 'ZdFooter',
                      color: 'transparent',
                      cssClass: 'zd-pt-3',
                      grid: {
                        cols: 3,
                      },
                      padless: true,
                      children: [
                        {
                          name: 'botaoInformacaoForm1',
                          component: 'ZdButton',
                          icon: true,
                          cssClass: 'zd-pt-1',
                          iconName: 'mdi-message-alert',
                          color: 'secondary',
                          events: {
                            click: '{{ModalControllerAddProcedimento.openHeaderFooterModal}}',
                          },
                        },
                        {
                          name: 'botaoInformacaoForm2',
                          component: 'ZdButton',
                          label: 'Adicionar',
                          color: 'info',
                          events: {
                            click: '{{ChecklistController.adicionaNovaTArefaCardAtividades}}',
                          },
                        },
                      ],
                    },
                  ],
                },
              ],
            },
          ],
        },
      ],
    };
  }

  public geraTarefaLinha(tarefa: string, criterio: string, tag: string) {
    this.modeloCriterio = {
      name: 'containerForms1',
      component: 'ZdRow',
      grid: {
        cols: '12',
      },
      children: [
        {
          name: 'linha',
          component: 'ZdRow',
          grid: {
            cols: '',
          },
          children: [
            {
              name: 'tarefas',
              component: 'ZdTextInput',
              label: 'Tarefa',
              value: `${tarefa}`,
              cssClass: 'zd-pr-1',
              validations: {
                required: '{}',
              },
              grid: {
                sm: '3',
              },
            },
            {
              name: 'criterioNovoChecklist1',
              component: 'ZdTextInput',
              label: 'Critério de Não-Conformidades',
              cssClass: 'zd-pr-1',
              value: `${criterio}`,
              validations: {
                required: '{}',
              },
              grid: {
                sm: '3',
              },
            },
            {
              name: 'tagNovoChecklist1',
              component: 'ZdTextInput',
              label: 'Tag de Serviço',
              value: `${tag}`,
              cssClass: 'zd-pr-1',
              validations: {
                required: '{}',
              },
              grid: {
                sm: 3,
              },
            },
            {
              name: 'form_footer1',
              component: 'ZdFooter',
              color: 'transparent',
              cssClass: 'zd-pt-3 ',
              events: {
                onCreated: '{{ModalControllerAddProcedimento.createHeaderFooterModal}}',
                onBeforeDestroy: '{{ModalControllerAddProcedimento.destroyHeaderFooterModal}}',
              },
              grid: {
                sm: '3',
              },
              padless: true,
              children: [
                {
                  name: 'botaoInformacaoForm1',
                  component: 'ZdButton',
                  icon: true,
                  iconName: 'mdi-message-alert',
                  color: 'secondary',
                  events: {
                    click: '{{ModalControllerAddProcedimento.openHeaderFooterModal}}',
                  },
                },
                {
                  name: 'botaoExcluirForm1',
                  component: 'ZdButton',
                  icon: true,
                  iconName: 'mdi-trash-can-outline',
                  color: 'secondary',
                  events: {
                    click: '{{ChecklistController.deletaCriterio}}',
                  },
                },
              ],
            },
          ],
        },
      ],
    };
  }

  // Cria uma nova linha padrão para cadastro de uma nova atividade
  public criaModeloLinha(tarefa: string, criterio: string, tag: string, descricao: string, pos: number) {
    this.modeloCriterio = [{
      name: `DadosTarefas${pos}`,
      component: 'ZdTextInput',
      label: 'Tarefa',
      value: `${tarefa}`,
      validations: {
        required: '{}',
      },
      grid: {
        cols: 4,
      },
    },
    {
      name: `DadosCriterio${pos}`,
      component: 'ZdTextInput',
      label: 'Critério de Não-Conformidades',
      value: `${criterio}`,
      validations: {
        required: '{}',
      },
      grid: {
        cols: 3,
      },
    },
    {
      name: `DadosTag${pos}`,
      component: 'ZdTextInput',
      label: 'Tag de Serviço',
      value: `${tag}`,
      validations: {
        required: '{}',
      },
      grid: {
        cols: 3,
      },
    },
    {
      name: `form_footer1${pos}`,
      component: 'ZdFooter',
      cssClass: 'zd-pt-3',
      color: 'transparent',
      padless: true,
      children: [
        {
          name: 'botaoInformacaoForm1',
          component: 'ZdButton',
          icon: true,
          iconName: 'mdi-message-alert',
          color: 'secondary',
          events: {
            click: '{{ChecklistController.getDescricao}}',
          },
          grid: {
            cols: 1,
          },
        },
        {
          name: 'botaoExcluirForm1',
          component: 'ZdButton',
          icon: true,
          iconName: 'mdi-trash-can-outline',
          color: 'secondary',
          events: {
            click: '{{ChecklistController.deletaCriterio}}',
          },
          grid: {
            cols: 1,
          },
        },
      ],
    },
    {
      name: `textareaResultModal${pos}`,
      component: 'ZdTextarea',
      value: `${descricao}`,
      isVisible: false,
    }];
  }

  // Função para troca titulo do botão ao acionar a tab Atividades e Critérios
  public trocaConteudoBotaoTabs() {
    const tabObject = Metadata.getInstance<Tabs>('tabsLocais');
    const buttonObject = Metadata.getInstance<Button>('botaoNovoChecklist');
    if (tabObject.activeTab === 0) {
      buttonObject.label = 'Nova Checklist';
    }
    if (tabObject.activeTab === 1) {
      buttonObject.label = 'Nova Atividade';
    }
  }

  // Fução para trocar conteudo e rota do botão ao trocar de aba
  public acaoBotaoAtividades({ component }: IEventParam<Button>) {
    if (component.label === 'Nova Atividade') {
      this.modalController.openHeaderFooterModal();
    } else {
      Router.replace('/cadastroNovoChecklist');
    }
  }

  // função para verificar onde esta pegando os componentes(Console.Log);
  public consoleLog(variavel: string) {
    const titulo = Metadata.getInstance<Text>('');
    titulo.text = variavel;
  }

  public isVisible() {
    const switchObject = Metadata.getInstance<Switch>('switch');
    const containerObject = Metadata.getInstance<Container>('container');
    const switchObject1 = Metadata.getInstance<Switch>('switch2');
    const containerObject1 = Metadata.getInstance<Container>('containerArquivo');
    if (switchObject.value) {
      containerObject.isVisible = true;
      switchObject1.disabled = true;
    } else if (switchObject1.value) {
      containerObject1.isVisible = true;
      switchObject.disabled = true;
    } else {
      containerObject.isVisible = false;
      containerObject1.isVisible = false;
      switchObject1.disabled = false;
      switchObject1.disabled = false;
    }
  }

  public showBasicAlert() {
    AlertService.show({ name: 'basic-alert', text: 'A basic alert' });
  }

  // Função para Salvar o modal de cadastro da atividades
  public salvarCardAtividades() {
    const selecLinhaNomeAtividade = Metadata.getInstance<Form>('rowLinhaNomeTarefa');
    const selectFormObject = Metadata.getInstance<Form>('formNovaAtividade');
    const validacao1 = selecLinhaNomeAtividade.validate();
    const validacao2 = selectFormObject.validate();
    if (validacao1 && validacao2) {
      AlertService.show({
        name: 'valid-form-alert',
        text: 'Nova Tarefa Cadastrada com Sucesso! ',
        color: 'info',
      });
      const indice = selectFormObject.children.map((nomesCampos: IDictionary) => nomesCampos.name);
      const teste = indice.filter((nome: string) => nome.indexOf('DadosTarefas') !== -1);
      const valor : IDictionary = [];
      teste.forEach((nome: string) => {
        const indiceNome = nome.substr(12);
        valor.push({
          NMTAREFA: selectFormObject.value[`DadosTarefas${indiceNome}`],
          CRITERIO: selectFormObject.value[`DadosCriterio${indiceNome}`].replace(';', ',').split(','),
          TAG: selectFormObject.value[`DadosTag${indiceNome}`].replace(';', ',').split(','),
          DESCRICAO: selectFormObject.value[`textareaResultModal${indiceNome}`],
        });
      });
      // Array que recebe os dados que serão passados para o BackEnd
      const todosOsDados = {
        NMATIVIDADE: Metadata.getInstance<TextInput>('atividade').value,
        TAREFAS: valor,
      };
      this.consoleLog(String(todosOsDados));
      this.modalController.closeHeaderFooterModal();
    } else {
      AlertService.show({
        name: 'invalid-form-alert',
        text: 'Favor preencher todos os campos',
        color: 'error',
      });
    }
  }

  public contador: number = 0;

  // Função para adicionar sempre uma nova tarefa acima no modal de cadastro de atividades
  public addNovoTarefasCriterioTag({ component }:{ component:Button }) {
    const form: any = component!.parent!.getChildInstance('formNovaAtividade');
    this.criaModeloLinha('', '', '', '', this.contador);
    this.contador += 1;
    form.children.push(this.modeloCriterio[0]);
    form.children.push(this.modeloCriterio[1]);
    form.children.push(this.modeloCriterio[2]);
    form.children.push(this.modeloCriterio[3]);
    form.children.push(this.modeloCriterio[4]);
  }

  // Remove uma tarefa adicionada.
  public deletaCriterio({ component }:{ component:Button }) {
    const linha = component!.parent!.parent;
    const variavel = linha!.children.map((dados: IDictionary) => dados.name);
    const variavel1 = variavel.indexOf(`DadosTarefas${component!.parent!.name.substr(12)}`);
    linha!.children.splice(Number(variavel1), 5);
  }

  public global: any = [];

  public getDescricao({ component }:{ component:Button }) {
    const variavel = component!.parent!.parent!.children[1];
    this.modalController1.openHeaderFooterModal();
    this.global = variavel;
  }

  public salvaDescricao() {
    const switchObject = Metadata.getInstance<Switch>('switch');
    if (switchObject.value) {
      this.global.value = Metadata.getInstance<Textarea>('textareaResult').value;
    } else {
      this.global.value = Metadata.getInstance<FileInput>('fileResult').storePath;
    }
    this.modalController1.closeHeaderFooterModal();
  }

  public editDescicao({ component }: IEventParam<Textarea>) {
    if (this.global.value != null) {
      const variavel = component!.parent!.parent!.children[1];
      variavel.value = true;
      this.isVisible();
      component.value = this.global.value;
    }
  }

  // Função para expandir e editar o card Atividades
  public editarCardAtividades({ component }: IEventParam<Button>) {
    const a = component.parent as IDictionary;
    if (!a.expanded) {
      a.expanded = !a.expanded;
      component.iconName = 'mdi-pencil';
      component.label = '';
      component.icon = true;
    } else {
      // const form = Metadata.getInstance<Form>('containerForms');
      a.expanded = !a.expanded;
      component.iconName = 'mdi-pencil';
      component.label = '';
      component.icon = true;
    }
  }

  public adicionaNovaTArefaCardAtividades({ component }:{ component:Form }) {
    const selectFormObject = component!.parent!.parent as IDictionary;
    if (selectFormObject.validate()) {
      // const selectObjectTarefa = Metadata.getInstance<TextInput>('tarefasNovoChecklist1').value;
      // const selectObjectCriterio = Metadata.getInstance<TextInput>('criterioNovoChecklist1').value;
      // const selectObjectTag = Metadata.getInstance<TextInput>('tagNovoChecklist1').value;
      // const selectObjectCampoDescricao = Metadata.getInstance<TextInput>('textareaResult');
      // const selectObjectDescricao = Metadata.getInstance<Textarea>('textareaResult').value;
      this.criaModeloLinha('', '', '', '', Object.keys(selectFormObject!.value).length);
      selectFormObject!.children.splice(selectFormObject!.children.length - 4, 0, this.modeloCriterio[0]);
      selectFormObject!.children.splice(selectFormObject!.children.length - 4, 0, this.modeloCriterio[1]);
      selectFormObject!.children.splice(selectFormObject!.children.length - 4, 0, this.modeloCriterio[2]);
      selectFormObject!.children.splice(selectFormObject!.children.length - 4, 0, this.modeloCriterio[3]);
      // selectFormObject.children.splice(selectFormObject.children.length - 4, 0, this.modeloCriterio[4]);
    }
  }
}
