import Vue from 'vue';
import Router from 'vue-router';
import { ZdPage } from '@zeedhi/vue';

Vue.use(Router);

const router = new Router({
  mode: 'history',
  base: process.env.BASE_URL,
  routes: [
    {
      path: '/',
      name: 'home',
      component: () => import('./views/Home.vue'),
    },
    {
      name: 'Tarefas',
      path: '/Tarefas',
      component: ZdPage,
      props: {
        path: 'tarefas',
        local: true,
      },
    },
    {
      name: 'Cadastramento_tarefas',
      path: '/Cadastramento',
      component: ZdPage,
      props: {
        path: 'cadastramentoTarefas',
        local: true,
      },
    },
    {
      name: 'test',
      path: '/test',
      component: ZdPage,
      props: {
        path: 'test',
        local: true,
      },
    },
    {
      path: '/zeedhi',
      name: 'zeedhi',
      component: ZdPage,
      props: () => ({
        path: 'zeedhi',
        local: true,
      }),
    },
    {
      path: '/login',
      name: 'login',
      component: ZdPage,
      props: () => ({
        path: 'login',
        local: true,
      }),
    },
    {
      path: '*',
      component: ZdPage,
      props: {
        path: 'notfound',
        local: true,
      },
    },
    {
      path: '/tipoLocal',
      component: ZdPage,
      props: {
        path: 'tipoLocal',
        local: true,
      },
    },
    {
      path: '/cadastroNovoChecklist',
      component: ZdPage,
      props: {
        path: 'cadastroNovoChecklist',
        local: true,
      },
    },
    {
      path: '/localAtendimento',
      component: ZdPage,
      props: {
        path: 'localAtendimento',
        local: true,
      },
    },
    {
      path: '/localAtendimento/:nr',
      component: ZdPage,
      props: {
        path: 'localAtendimento',
        local: true,
      },
    },
    {
      path: '/checklist',
      component: ZdPage,
      props: {
        path: 'checklist',
        local: true,
      },
    },
    {
      path: '/gerenciarLocais',
      component: ZdPage,
      props: {
        path: 'gerenciarLocais',
        local: true,
      },
    },
    {
      path: '/agrupamentoSimples/:bloco',
      component: ZdPage,
      props: {
        path: 'agrupamentoSimples',
        local: true,
      },
    },
    {
      path: '/funcionarios',
      component: ZdPage,
      props: {
        path: 'funcionarios',
        local: true,
      },
    },
  ],
});

export const getRoutePath = () => {
  const { currentRoute } = router;
  const { path } = currentRoute;
  return path;
};

export const getRouteParams = () => {
  const { currentRoute } = router;
  const { params } = currentRoute;
  return params;
};

export default router;
